<?php # Skrypt 13.6 - register.php
// Strona przeznaczona do rejestrowania uytkownikw witryny.

// Doczamy plik konfiguracyjny z procedurami obsugi bdw.
require_once ('./includes/config.inc.php'); 

// Ustawiamy tytu strony i doczamy nagwek HTML.
$page_title = 'Rejestracja';
include ('./includes/header.html');

if (isset($_POST['submitted'])) { // Obsugujemy formularz.

  require_once ('../mysql_connect.php'); // czymy si z baz danych.
    
  // Sprawdzamy imi.
  if (eregi ('^[[:alpha:]\.\' \-]{2,15}$', stripslashes(trim($_POST['first_name'])))) {
    $fn = escape_data($_POST['first_name']);
  } else {
    $fn = FALSE;
    echo '<p><font color="red" size="+1">Prosz poda imi!</font></p>';
  }
  
  // Sprawdzamy nazwisko.
  if (eregi ('^[[:alpha:]\.\' \-]{2,30}$', stripslashes(trim($_POST['last_name'])))) {
    $ln = escape_data($_POST['last_name']);
  } else {
    $ln = FALSE;
    echo '<p><font color="red" size="+1">Prosz poda nazwisko!</font></p>';
  }
  
  // Sprawdzamy adres e-mail.
  if (eregi ('^[[:alnum:]][a-z0-9_\.\-]*@[a-z0-9\.\-]+\.[a-z]{2,4}$', stripslashes(trim($_POST['email'])))) {
    $e = escape_data($_POST['email']);
  } else {
    $e = FALSE;
    echo '<p><font color="red" size="+1">Prosz poda prawidowy adres e-mail!</font></p>';
  }

  // Sprawdzamy haso i porwnujemy je z potwierdzeniem hasa.
  if (eregi ('^[[:alnum:]]{4,20}$', stripslashes(trim($_POST['password1'])))) {
    if ($_POST['password1'] == $_POST['password2']) {
      $p = escape_data($_POST['password1']);
    } else {
      $p = FALSE;
      echo '<p><font color="red" size="+1">Naley dwukrotnie wpisa to samo haso!</font></p>';
    }
  } else {
    $p = FALSE;
    echo '<p><font color="red" size="+1">Prosz poda prawidowe haso!</font></p>';
  }
  
  if ($fn && $ln && $e && $p) { // Jeli wszystko jest w porzdku...

    // Sprawdzamy, czy adres e-mail nie zosta ju zarejestrowany.
    $query = "SELECT user_id FROM users WHERE email='$e'";    
    $result = mysql_query ($query) or trigger_error("Zapytanie: $query\n<br />Bd MySQL: " . mysql_error());
    
    if (mysql_num_rows($result) == 0) { // Adres jest wolny.
    
      // Tworzymy kod aktywacyjny.
      $a = md5(uniqid(rand(), true));
    
      // Dodajemy kont uytkownika.
      $query = "INSERT INTO users (email, pass, first_name, last_name, active, registration_date) VALUES ('$e', SHA('$p'), '$fn', '$ln', '$a', NOW() )";    
      $result = mysql_query ($query) or trigger_error("Zapytanie: $query\n<br />Bd MySQL: " . mysql_error());

      if (mysql_affected_rows() == 1) { // Jeli zapytanie zostao wykonane prawidowo...
      
        // Wysyamy wiadomo e-mail.
        $body = "Dzikujmy za zarejestrowanie si w systemie rejestracji uytkownikw. Aby uaktywni swoje konto, kliknij ponisze cze:\n\n";
        $body .= "http://www.localhost.com/html/activate.php?x=" . mysql_insert_id() . "&y=$a";
        mail($_POST['email'], 'Potwierdzenie rejestracji', $body);
        
        // Koczymy stron.
        echo '<h3>Dzikujemy za zarejestrowanie si! Pod Twj adres zostaa wysana wiadomo e-mail z potwierdzeniem rejestracji. Kliknij cze w tej wiadomoci, aby uaktywnic swoje konto.</h3>';
        include ('./includes/footer.html'); // Doczamy stopk HTML.
        exit();        
        
      } else { // Jeli zapytanie nie zostao wykonane prawidowo...
        echo '<p><font color="red" size="+1">Konto nie zostao zarejestrowane ze wzgldu na bd systemu. Przepraszamy za niedogodno.</font></p>'; 
      }    
      
    } else { // Adres e-mail jest ju zarejestrowany.
      echo '<p><font color="red" size="+1">Ten adres e-mail jest ju zarejestrowany. Jeli zapomniae hasa, kliknij odpowiednie cze, a przelemy haso pod Twj adres.</font></p>'; 
    }
    
  } else { // Jeli nie powid si ktry z testw danych...
    echo '<p><font color="red" size="+1">Prosz sprbowa jeszcze raz.</font></p>';    
  }

  mysql_close(); // Zamykamy poczenie z baz danych.

} // Koniec gwnej instrukcji warunkowej sprawdzajcej, czy formularz zosta przesany.
?>
  
<h1>Rejestracja</h1>
<form action="register.php" method="post">
  <fieldset>
  
  <p><b>Imi:</b> <input type="text" name="first_name" size="15" maxlength="15" value="<?php if (isset($_POST['first_name'])) echo $_POST['first_name']; ?>" /></p>
  
  <p><b>Nazwisko:</b> <input type="text" name="last_name" size="30" maxlength="30" value="<?php if (isset($_POST['last_name'])) echo $_POST['last_name']; ?>" /></p>
  
  <p><b>Adres e-mail:</b> <input type="text" name="email" size="40" maxlength="40" value="<?php if (isset($_POST['email'])) echo $_POST['email']; ?>" /> </p>
    
  <p><b>Haso:</b> <input type="password" name="password1" size="20" maxlength="20" /> <small>Haso powinno zawiera od 4 do 20 znakw (tylko litery i cyfry).</small></p>
  
  <p><b>Potwierdzenie hasa:</b> <input type="password" name="password2" size="20" maxlength="20" /></p>
  </fieldset>
  
  <div align="center"><input type="submit" name="submit" value="Rejestracja" /></div>
  <input type="hidden" name="submitted" value="TRUE" />

</form>

<?php // Doczamy stopk HTML.
include ('./includes/footer.html');
?>
